<template>
  <div class="welcome page" :class="{loading: isLoading == true}" :style="{'backgroundImage': 'url('+bgImg+')'}">
      <div class="page-wrapper" v-if="$config.venue != ''">
        <img :src="this.$logoimg" width="110"/>
        <div class="space-lg" />
        <h1 class="font-size-title">无边界酒吧</h1>
        <div class="space-md" />
        <img :src="scanIcon" width="181"/>
        <div class="space-md" />
        <div v-if="isFocus == true">
          <div class="font-size-heading" >请扫描您的专属二维码领取轩尼诗特调</div>
        </div>
        <div v-if="isFocus == false">
          <a class="btn-brand btn-lg" @click="focusInput">開始</a>
        </div>
        <div id="qrInput" v-text="userId"></div>
      </div>
      <div class="page-wrapper" v-if="$config.venue == ''">
        <img :src="this.$logoimg" width="110"/>
        <h2>请联络我们的工作人员设定装置</h2>
      </div>
  </div>
</template>

<script>
import JQuery from 'jquery'

export default {
  name: 'Welcome',
  data () {
    return {
      isLoading: false,
      api: this.getApi(),
      bgImg: require('../../assets/bg_welcome.jpg'),
      userId: '',
      scanIcon: require('../../assets/scan-icon.png'),
      keyboardTimeout: 2000,
      timeoutFn: function(){},
      isFocus: false,
    }
  },
  methods: {
      getApi: function(){
        var _venue = this.getCookie("order_hennessy_venue");
        if(_venue == '' || _venue == 'undefined' || _venue  == null){
          this.$router.push('/config')
          return false;
        }
        return this.$config.api_url[_venue].api_prefix;
      },
      goSelectPage: function(){
        var vm = this;
        if( vm.$config.venue == 'shanghai' ){
          vm.$router.push({ 
            path: '/select-shanghai',
          })
        }else if( vm.$config.venue == 'malaysia' ){
          vm.$router.push({ 
            path: '/select-malaysia',
          })
        }
      },
      goRedeemedPage: function(){
        var vm = this;
        vm.$router.push({ 
          path: '/redeemed',
        })
      },
      focusInput: function(){
        this.isFocus = true;
      },
      scanQr: function(){
        var vm  = this;
        vm.userId = vm.userId.replace('Enter', '');
        var submitData = {
          userId: vm.userId
        }
        vm.isLoading = true;
        JQuery.post(vm.api + '/api/barWelcome',submitData)
        .done(function(response){
          vm.isLoading = false;
          console.log(vm.api + '/api/barWelcome : response: ', response);
          if(typeof(response.result) == "number"  && response.result < 0){
            vm.userId = '';
            alert('未能辨识二维码，新重新扫瞄')
            return;
          }
          var data = response;
          vm.$config.user = Object.assign({},vm.$config.user,data)
          var userInfo = vm.$config.user;


          if( vm.$config.venue == 'shanghai' ){
            if(userInfo.quota.free >= 1){
              vm.goSelectPage();
            }else{
              vm.goRedeemedPage();
            }
          }else if(vm.$config.venue == 'malaysia'){
            if(userInfo.quota.free > 0 && userInfo.quota.local >= 2 || userInfo.quota.international >= 2 ){
              vm.goRedeemedPage();
            }else{
              vm.goSelectPage();
            }
          }
        })
        .fail(function(){
          vm.isLoading = false;
          vm.userId = '';
          alert('未能辨识二维码，新重新扫瞄')
        })
        /*vm.$axios
        .post(vm.api + '/api/barWelcome', submitData)
        .then(function(response){
          console.log(vm.api + '/api/barWelcome : response: ', response);
          var data = response.data;
          vm.$config.user = Object.assign({},vm.$config.user,data)

          var userInfo = vm.$config.user;

          if( vm.$config.venue == 'shanghai' ){
            if(userInfo.quota.free < 1){
              vm.goSelectPage();
            }else{
              vm.goRedeemedPage();
            }
          }else if(vm.$config.venue == 'malaysia'){
            if(userInfo.quota.free > 0 && userInfo.quota.local >= 2 || userInfo.quota.international >= 2 ){
              vm.goRedeemedPage();
            }else{
              vm.goSelectPage();
            }
          }
          
        })
        .catch(function(error){
          console.log(error)
        })*/
        
        /*var sampleReturn = {
          userId: vm.userId,
          userName: 'chanchukei',
          quota: {
            international:  0,
            local:        0,
            free:         2,
          }
        }*/
        
      },
      onKeyboardFn: function(e){
        var vm = this;
        //clearTimeout(vm.timeoutFn);
        if(vm.isLoading == true){
          return;
        }
        const currentCode = event.which || event.code;
        let currentKey = event.key;
        if (!currentKey) {
          currentKey = String.fromCharCode(currentCode);
        }
        vm.userId = vm.userId + currentKey;

        if(vm.userId.indexOf('Enter') > 0){
          vm.scanQr();
        }
        /*vm.timeoutFn = setTimeout(function(){
          vm.scanQr();
        },vm.keyboardTimeout);*/
      },
      evt: function(){
        var vm = this;
        window.addEventListener('keypress', vm.onKeyboardFn)
      },
      unbindEvt: function(){
        var vm = this;
        window.removeEventListener('keypress', vm.onKeyboardFn)
      },
      checkCookie: function(){
        var vm = this;
        var hennessy_venue = vm.getCookie("order_hennessy_venue");

        if (hennessy_venue == 'shanghai') {
          vm.$config.venue = hennessy_venue;
          // start shanghai stand setup
          var hennessy_stand = vm.getCookie("order_hennessy_stand");
          vm.$config.stand = hennessy_stand;
          // end shanghai stand setup
        }else if( hennessy_venue =='malaysia' ){
          vm.$config.venue = hennessy_venue;
        }else {
          vm.$router.push({ 
            path: '/config' 
          })
        }
      },
      getCookie: function(cname) {
          var name = cname + "=";
          var decodedCookie = decodeURIComponent(document.cookie);
          var ca = decodedCookie.split(';');
          for(var i = 0; i <ca.length; i++) {
              var c = ca[i];
              while (c.charAt(0) == ' ') {
                  c = c.substring(1);
              }
              if (c.indexOf(name) == 0) {
                  return c.substring(name.length, c.length);
              }
          }
          return "";
      },
      resetData: function(){
        this.$config.user = {};
      }
  },
  mounted: function(){
    this.checkCookie();
    this.resetData();
    this.evt();
    this.isFocus = true;
  },
  beforeDestroy() {
    this.unbindEvt();
    this.isFocus = false;
  },
}
</script>

<style scoped lang="sass">
@import "../../styles/pages/welcome.sass"
</style>
